# Defend The Castle

[![Downloads](https://img.shields.io/npm/dt/defend-the-castle.svg?style=flat-square)](https://npmjs.org/package/defend-the-castle) [![Node](https://img.shields.io/node/v/defend-the-castle.svg?style=flat-square)](https://npmjs.org/package/defend-the-castle) [![Version](https://img.shields.io/npm/v/defend-the-castle.svg?style=flat-square)](https://npmjs.org/package/defend-the-castle) [![XO code style](https://img.shields.io/badge/code%20style-XO-red.svg?style=flat-square)](https://github.com/xojs/xo) 

Telegram Bot Game - Defend The Castle

## Installation

Module available through the [npm registry](https://www.npmjs.com/). It can be installed using the  [`npm`](https://docs.npmjs.com/getting-started/installing-npm-packages-locally) or [`yarn`](https://yarnpkg.com/en/) command line tools.

```sh
# NPM
npm install defend-the-castle --save
# Or Using Yarn
yarn add defend-the-castle
```

## Tests

To run the test suite, first install the dependencies, then run `test`:

```sh
# NPM
npm test
# Or Using Yarn
yarn test
```

## Dependencies

<details>
	<summary><a href="https://ghub.io/brain.js">brain.js</a>: Neural networks in JavaScript</summary>
	<b>Author</b>: Heather Arthur</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 1.6.1
</details>
<details>
	<summary><a href="https://ghub.io/cron">cron</a>: Cron jobs for your node</summary>
	<b>Author</b>: Nick Campbell</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: ^1.7.1
</details>
<details>
	<summary><a href="https://ghub.io/debug">debug</a>: small debugging utility</summary>
	<b>Author</b>: TJ Holowaychuk</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 4.1.1
</details>
<details>
	<summary><a href="https://ghub.io/json-stringify-safe">json-stringify-safe</a>: Like JSON.stringify, but doesn&#x27;t blow up on circular refs.</summary>
	<b>Author</b>: Isaac Z. Schlueter</br>
	<b>License</b>: ISC</br>
	<b>Version</b>: 5.0.1
</details>
<details>
	<summary><a href="https://ghub.io/lodash">lodash</a>: Lodash modular utilities.</summary>
	<b>Author</b>: John-David Dalton</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 4.17.11
</details>
<details>
	<summary><a href="https://ghub.io/minimist">minimist</a>: parse argument options</summary>
	<b>Author</b>: James Halliday</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 1.2.0
</details>
<details>
	<summary><a href="https://ghub.io/moment">moment</a>: Parse, validate, manipulate, and display dates</summary>
	<b>Author</b>: Iskren Ivov Chernev</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 2.24.0
</details>
<details>
	<summary><a href="https://ghub.io/moment-timezone">moment-timezone</a>: Parse and display moments in any timezone.</summary>
	<b>Author</b>: Tim Wood</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 0.5.25
</details>
<details>
	<summary><a href="https://ghub.io/nodejs-i18n">nodejs-i18n</a>: Minimalistic internationalization using gettext style for NodeJS</summary>
	<b>Author</b>: TiagoDanin</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 2.3.0
</details>
<details>
	<summary><a href="https://ghub.io/numberlabel">numberlabel</a>: Convert a large number to nice formatted string.</summary>
	<b>Author</b>: Tiago Danin</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 1.0.1
</details>
<details>
	<summary><a href="https://ghub.io/pg">pg</a>: PostgreSQL client - pure javascript &amp; libpq with the same API</summary>
	<b>Author</b>: Brian Carlson</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 7.11.0
</details>
<details>
	<summary><a href="https://ghub.io/pg-native">pg-native</a>: A slightly nicer interface to Postgres over node-libpq</summary>
	<b>Author</b>: Brian M. Carlson</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 3.0.0
</details>
<details>
	<summary><a href="https://ghub.io/telegraf">telegraf</a>: Modern Telegram Bot Framework</summary>
	<b>Author</b>: Vitaly Domnikov</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 3.30.1
</details>
<details>
	<summary><a href="https://ghub.io/telegraf-start-parts">telegraf-start-parts</a>: Command /start parameters parser middleware for Telegraf</summary>
	<b>Author</b>: Tiago Danin</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 1.0.0
</details>

## Dev Dependencies

<details>
	<summary><a href="https://ghub.io/env-cmd">env-cmd</a>: Executes a command using the environment variables in an env file</summary>
	<b>Author</b>: Todd Bluhm</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 9.0.3
</details>
<details>
	<summary><a href="https://ghub.io/nodemon">nodemon</a>: Simple monitor script for use during development of a node.js app.</summary>
	<b>Author</b>: Remy Sharp</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 1.19.0
</details>
<details>
	<summary><a href="https://ghub.io/xo">xo</a>: JavaScript linter with great defaults</summary>
	<b>Author</b>: Sindre Sorhus</br>
	<b>License</b>: MIT</br>
	<b>Version</b>: 0.24.0
</details>

## Contributors

Pull requests and stars are always welcome. For bugs and feature requests, please [create an issue](https://github.com/TiagoDanin/Defend-The-Castle/issues). [List of all contributors](https://github.com/TiagoDanin/Defend-The-Castle/graphs/contributors).

## License

[MIT](LICENSE) © [Tiago Danin](https://TiagoDanin.github.io)